# Voir les RQs préliminaires 1,2 & 3 
--- # Séparateur bin les blocs 
- name: Configure ngnix webserver # Esm ll play
  hosts: localhost # N7oto @ip ou esm groupe de host mn bin eli ma7toutin fl fichier hosts  
  tasks: # Chnowa thb tlansi 3al srévér héthom .. tasnéch liste de tasks na3mlou tasks : w n7élou b - - - etc .. 
  - name: install ngnix server # Esm ll task 
    ansible.builtin.apt: # hétha yétsama module .. kn jina nkhdmo 3al serveur toul raw lancina apt install ngnix .. son module ansible équivalent haka yét3ml 
      name: ngnix=version # esm pack li thb tinstallih 
      state: present # Version pack li thb tinstallih
    # RQ (apt): dns le cas ou thb tinstalli version spécifique d'un pack comment faire ? : 
    #name: ngnix=version 
    #state: present  # RQ : kén nhb nfasa5 pack .. state: absent  
    # + Voir RQ 4 + 5 
  - name: start ngnix service
    ansible.builtin.service: # module service .. bch ya3ml start ll service ..
      name: ngnix 
      state: started # RQ (service): kén nhb nstoppi service .. state: stopped

- name: Create a new Linux user 
  hosts: localhost
  tasks: 
  - name: ....
    ansible.builtin.user:   # Voir RQ 13
      name: SBH 
      group: admin # El group li bch yéntamilo user 
      append: yes

- name: Deploy NodeJS Application on server  
  hosts: 159.89.1.54
  become: True  # Ta3tik 7a9 bch tbadél user li dkhalt biha 9bal matlansi play 
  become_user: Esm_user_jdid # Chnowa user li thb t7awélo 
    # + Voir RQ 14
  vars_files: 
						- project-vars.yaml 
  tasks:
    - name: Copy the files 
      ansible.builtin.copy: 
			  src: /path_to_file_to_copy_in_local  # Voir RQ 6 ll module copy + RQ 15 pour executer ce play avec user autre que li authentifit bih
			  dest: /path_to_file_to_copy_in_server 
    - name: Unziping the file 
      ansible.builtin.unarchive: 
        src: /path_to_file_to_unarchive_in_server # Voir RQ 7 
			  dest: /path_to_folder_where_to_unarchive # RQ : hna thot /root khw mch /root/package (juste esm dossier li bch tunzipi fih si nn y9olk folder not found )
			  remote_src: yes # ma3néha src lézm ylawéj aliha fl serveur .. mch fl local .. si nn erreur 
    - name: Installing Packs 
      mpm: 
        path: /path_to_folder_containing_package.json # package.json contien les dependances lézmin 
        # w mpm howa yinstallihom 
    - name: Lanching linux Command  
      ansible.builtin.command: 
        chdir: /path_win_thb_tlansi_command
        cmd: # El command li thb tlansiha 
      async: 1000 # Voir RQ 8 
      poll: 0
    - name: Ensure App is running 
      ansible.builtin.shell: 
        chdir: /home/user
        cmd: ps aux | grep node # Command li thb tlansiha  # Voir RQ 9 + 12 
      register: app_status # Esm variable li bch tsob fiha output module # Voir RQ 10 
    - name: Printing output 
      ansible.builtin.debug: msg={{app_status.stdout_lines}} # Voir RQ 11 
      # NB : fama syntaxe héthi zéda : 
        #ansible.builtin.debug: 
        #var: docker_var
      








